#include "TM1636.h"
#include <math.h>
#include "functions.h"

//Pins für das RTC Shield
//#define CLK 7
//#define DATA 8

//Pins für das Rich Shield
#define CLK 10
#define DATA 11

TM1636 tm1636(CLK, DATA);

//An welchem analogen Pin der NTC-Widerstand angeschlossen ist
#define PIN A1 

const int ntcWiderstand = 10000; // NTC-Widerstand mit 10 kOhm
const int MAX_ANALOG_VALUE = 1023;


void setup(){
  Serial.begin(9600);
  //Initialisieren der Anzeige.
  tm1636.init();
}

void loop(){      
  double analogValue = analogRead(PIN);
  
  // Konvertieren des analogen Wertes in ein Widerstandswert
  double resistorValue = (MAX_ANALOG_VALUE / analogValue)- 1; 
  resistorValue = ntcWiderstand / resistorValue;

  double kelvin = convert2TempKelvin(analogValue);
  double celsius = convertKelvin2TempCelsius(kelvin);
    
  tm1636.display(getNumber(celsius));         
  
  delay(1000); //eine kleine Pause 1sek.
}

double convert2TempKelvin(float value){
  double temp = log(((10240000/value) - ntcWiderstand));
  temp = 1 / (0.001129148 + (0.000234125 * temp) + (0.0000000876741 * temp * temp * temp));
  return temp;
}

double convertKelvin2TempCelsius(double kelvin){
 return kelvin - 273.15;
}
