#include <stdint.h>
#include "constants.h"

//Liste mit den verfügbaren Zeichen
int8_t values[] = {
    NUM_0, NUM_1, NUM_2, NUM_3,
    NUM_4, NUM_5, NUM_6, NUM_7,
    NUM_8, NUM_9};

//Liste mit 4 "Speicherplätzen" für die Anzeige.
//Jeder Platz in der Liste ist für ein Teil der 
//4fach 7 Segmentanzeige.
int8_t disp[4];

void convertNumbers(int number, int offset){
   int8_t result[2];
   int bits = -1+offset;
   String numbers = String(number);
   
   if(number < 10){
     disp[++bits] = NUM_0;
     int firstChar = numbers.charAt(0)-ASCII_OFFSET;
     disp[++bits] = values[firstChar];
   } else {
     int firstChar = numbers.charAt(0)-ASCII_OFFSET;
     int secondChar = numbers.charAt(1)-ASCII_OFFSET;
     disp[++bits] = values[firstChar];
     disp[++bits] = values[secondChar];
   }
}

int8_t* getTime(int hours, int minutes){
   convertNumbers(hours,0);
   convertNumbers(minutes,2);
   return disp;
}

int8_t* getNumber(double value){
    String temp = String(value, 0);
    int bits = -1;

    if(value < 1000){
      disp[++bits] = SPACE;    
    }

    if(value < 100 && value > 0){
      disp[++bits] = SPACE;    
    } else if(value < 0){
      disp[++bits] = NEGATIVE_SIGN;    
    } 

    if(value < 10 && value > 0){
      disp[++bits] = SPACE;    
    }
    
    for(int i = 0;i< temp.length();i++){
        int pos = temp.charAt(i);
        if(pos >= 48 && pos <= 57){
          pos = pos - ASCII_OFFSET;          
          disp[++bits] = values[pos];
        }        
    }

    return disp;
}
